# include utility script
# source("lak_topic_modeling2.R")
# Authors: Vitomir Kovanovic,    Srećko Joksimovi?
#          v.kovanovic@ed.ac.uk  sjoksimo@sfu.ca
# Addtional comments: Go ota
# The original programs are used in LAK 2013 workshop
# Modified:
# Modified for Japanese with using RMeCab by Go Ota  2015/06/22

source("lak_topic_modeling2.R")
library(slam)
library(RMeCab)
library (tm) # 
library(topicmodels)

# add by G.Ota
# Change No.2 if you want to change output file names, @lease change the "project.id"
project.id <- "TA_Sample_JHigh_0622"
# seq (start k, end k, increment)
# Change No.3 if you want to change Max K tested, please change next parameters
all.ks <- seq(2, 40, 2) # what values of K to check?

# dtm <- build.dtm(load.dir="./data/Curi_JPHinfo_Fr/",
#                 tf.threshold=0.95,
#                 tf.idf.threshold=0.9,
#                 tf.idf.function="median",
#                 stemming=T,
#                 stopwords.removal=T,
#                 minWordLength=3,
#                 removeNumbers=T,
#                 removePunctuation=T,
#                 minDocFreq=3)

# Modified for MeCab
# Change No.4 first parameter is a directory that contains target text files
test <- docMatrix2( "data/sample", pos = c("","")) # 

# Operation N0.1
write.csv(test, file = paste(project.id,".csv", sep = ""))
write.csv(test, file = paste(project.id,"Org.csv", sep = ""))
# you should clean words. here
test = read.csv(paste(project.id,".csv", sep = ""), row.names=1)

test.sparse <-  as.simple_triplet_matrix( t(test) ) #
test.sparse2 <-  as.DocumentTermMatrix ( test.sparse, weighting = weightTf ) #
dtm <- test.sparse2

# alpha is dummy parameter now.
# build all topic models with different values of K
fileExist <- FALSE
all.topic.models <- build.topic.models(dtm, all.ks, alpha=1.0, fileExist)

# select best model
# calculate all harmonic mean scores and find best K
best.model <- get.best.model(all.topic.models)

paste("Best k is",best.model@k )

# add by G.Ota 2015/06/23
# If you change best.model
# MyK <- 13   
# best.model <- all.topic.models[[MyK]]
# best.model@k

# Make file of terms
max_terms <- 10
t_terms <- terms(best.model, max_terms)
write.csv(t_terms, file = paste(project.id,"Terms.csv", sep = ""))

# Make file of Gamma
write.csv(best.model@gamma, file = paste(project.id,"Gamma.csv", sep = ""))

# Make List of Topics
max_topics <- 3
t_topics <- topics(best.model, max_topics, threshold = 0.09)
write.topics(t_topics, paste(project.id,"Topics.csv", sep = ""))

# end add 2015/06/23

#Output results
document.topic.assignments <- get.topic.assignments(best.model) # assign all documents to most likely topics
log.message("\n\n********************************************")
print.topics.and.term(document.topic.assignments, best.model, n.terms=10) # print LDA results
# most topics
print.topics.filenames(document.topic.assignments,"./data/sample/") # print document filenames
print.nth.line(document.topic.assignments, "./data/sample/") # print document headlines


